#include<bits/stdc++.h>
#define ll long long
using namespace std;
bool Resenje(vector<ll> a,int k)
{
    int aura=0;
    for(int i=0;i<a.size();i++)
    {
       if(a[i]>=aura)
       {
           aura++;
       }
       else{
           aura--;
       }
    }
    return aura==k;
}
int main()
{
    int t,n,k;
    vector<ll> a,b;
    cin>>t>>n>>k;
    for(int i=0;i<n;i++)
    {
        ll x;
        cin>>x;
        a.push_back(x);
    }
    sort(a.begin(),a.end());
    int j=0;
    while(a[j]<0)
    {
        j++;
    }
    vector<int>b;
    int res=n-k/2;
    for(int i=1;i<2*res-j;i++)
    {
        b.push_back(a[n-i]);
        b.push_back(a[j+i]);
    }
    for(int i=0;i<j;i++)
    {
        b.push_back(a[i]);
        
    }
    for(int i=0;i<n-2*res;i++)
    {
        b.push_back(a[2*res+i]);
    }
    if(Resenje(b,k)){
        cout<<"DA"<<endl;
        for(int i=0;i<b.size();i++)
        {
            cout<<b[i]<<" ";
        }
    }
    else{
        cout<<"NE"<<endl;
    }




}